package Libconf::GUI::Gtk2::Entry;

use ugtk2 qw(:helpers :wrappers :create);
use Libconf::GUI::Gtk2::Widget;

# multiple inheritance, yaaaaaaaaaaaaaaa
our @ISA = qw(Gtk2::Entry Libconf::GUI::Gtk2::Widget);

#constructor
#@widget_options is optional
sub new {
    my ($class, $default, $ref_value, $data_mapping, @widget_options) = @_;
    my $self = $class->SUPER::new(@widget_options);
    $self->{default_value} = $default;
    $self->{data_mapping} = $data_mapping;
    $self->{ref_value} = $ref_value;
    bless $self, $class;
    gtksignal_connect($self, changed => sub {
                          my ($widget) = @_;
                          my $value = $widget->get_text();
                          print " setting : -- " . $value . "\n";
                          $self->set_value($value);
                          print " getvalue : -- " . $self->get_value() . "\n";
                      });
    return $self;
}

sub set_value {
    my $self = shift;
    $self->set_text($self->SUPER::set_value(@_));
}

1;

